package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.TokenCheckDTO;
import com.diagbot.dto.TokenHospitaDTO;
import com.diagbot.entity.TokenHospital;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.service.impl.TokenHospitalServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.DateUtil;
import com.diagbot.vo.TokenHospitalVO;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * @author wangfeng
 * @Description:
 * @date 2020-07-29 13:43
 */
@Component
public class TokenHospitalFacade extends TokenHospitalServiceImpl {

    /**
     * @param tokenHospitalVO
     * @return
     */
    public TokenHospitaDTO getTokenHospitals(TokenHospitalVO tokenHospitalVO) {
        TokenHospitaDTO tokenHospitaDTO = new TokenHospitaDTO();
        QueryWrapper<TokenHospital> tokenHospitalQuery = new QueryWrapper<>();
        tokenHospitalQuery.eq("is_deleted", IsDeleteEnum.N.getKey())
                .eq("appid_token", tokenHospitalVO.getAppidyToken());
        TokenHospital tokenHospital = getOne(tokenHospitalQuery, false);
        BeanUtil.copyProperties(tokenHospital, tokenHospitaDTO);
        return tokenHospitaDTO;
    }

    /**
     * @param token
     * @return
     */
    public TokenCheckDTO checkTokenHospitals(String token) {
        Date now = DateUtil.now();
        boolean res = true;
        //根据token获取用户id
        TokenHospitalVO tokenHospitalVO = new TokenHospitalVO();
        tokenHospitalVO.setAppidyToken(token);
        TokenHospitaDTO tokenHospitals = getTokenHospitals(tokenHospitalVO);
        int validDays = tokenHospitals.getValidDays();
        Date startTime = tokenHospitals.getStartTime();
        Date endTime = tokenHospitals.getEndTime();
        if (validDays < 0) {
            res = false;
            //throw new CommonException(CommonErrorCode.NOT_EXISTS, "已超过有效期");
        }
        if (DateUtil.before(now, startTime)) {
            res = false;
            //throw new CommonException(CommonErrorCode.NOT_EXISTS, "已超过有效期");
        }
        if (DateUtil.after(now, endTime)) {
            res = false;
            // throw new CommonException(CommonErrorCode.NOT_EXISTS, "已超过有效期");
        }

        TokenCheckDTO tokenCheckDTO = new TokenCheckDTO();
        tokenCheckDTO.setRes(res);
        tokenCheckDTO.setHospitalId(tokenHospitals.getHospitalId());
        return tokenCheckDTO;
    }
}
