package com.diagbot.web;


import com.diagbot.annotation.SysLogger;
import com.diagbot.facade.LisConfigFacade;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

/**
 * <p>
 * 化验公表映射 前端控制器
 * </p>
 *
 * @author zhaops
 * @since 2020-07-28
 */
@RestController
@RequestMapping("/tran/lisConfig")
@Api(value = "化验公表映射API", tags = { "化验公表映射API" })
public class LisConfigController {
    @Autowired
    private LisConfigFacade lisConfigFacade;

    /**
     * 化验公表数据导入
     *
     * @param file
     * @return
     */
    @ApiOperation(value = "化验公表数据导入[by:zhaops]",
            notes = "")
    @PostMapping("/importExcel")
    @SysLogger("importExcel")
    public void importExcel(@RequestParam("file") MultipartFile file) {
        lisConfigFacade.importExcel(file);
    }
}
